//+------------------------------------------------------------------+
//|                                     ind_CorrelationMAMACD_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 1
#property indicator_buffers 1
#property indicator_color1 Red

//---- input parameters
extern int CorPeriod=14;
extern int MAPeriod=14;
extern int MAMethod=0; // 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int MAPrice=0; // 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern int MACDFastPeriod=12;
extern int MACDSlowPeriod=26;
       int MACDSignalPeriod=9;
extern int MACDPrice=0; // 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
 
//---- buffers
double cor[];
double ind1[];
double ind2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   IndicatorBuffers(3);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,cor);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ind1);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ind2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               ind1[i]=iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i);
               ind2[i]=iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,MACDSignalPeriod,MACDPrice,MODE_MAIN,i);
                  double SXX=0;
                  double SYY=0;
                  double SXY=0;
                  double SumXY=0,SumXX=0,SumYY=0,SumY=0,SumX=0;         
                     for(int j=0;j<CorPeriod;j++){
                        double X=ind1[i+j];
                        double Y=ind2[i+j];
                        SumXY+=X*Y; 
                        SumXX+=X*X;
                        SumYY+=Y*Y;
                        SumY+=Y;   
                        SumX+=X;  
                     }
                  SXY=CorPeriod*SumXY-SumY*SumX; 
                  SXX=CorPeriod*SumXX-SumX*SumX;
                  SYY=CorPeriod*SumYY-SumY*SumY;
                  cor[i]=cor[i+1];
                     if (NormalizeDouble(SXX,8)!=0.0 && NormalizeDouble(SYY,8)!=0){
                        cor[i]=SXY/(MathSqrt(MathAbs(SXX*SYY)));  
                     }  
            }
            
            
   return(0);
  }
//+------------------------------------------------------------------+